## gate.jape
Class BasicPatternElement

    java.lang.Object
      |
      +--gate.jape.PatternElement
            |
            +--gate.jape.BasicPatternElement

All Implemented Interfaces:
  Cloneable, JapeConstants, Matcher, Serializable

public class BasicPatternElement
extends PatternElement
implements JapeConstants, Serializable

A pattern element within curly braces. Has a set of Constraint, which all must be satisfied at whatever position the element is being matched at.

See Also:
  Serialized Form

Fields inherited from interface gate.jape.JapeConstants
`APPELT_STYLE, BRILL_STYLE, DEFAULT_PRIORITY, FIRST_STYLE, INDENT_PADDING, KLEENE_PLUS, KLEENE_QUERY, KLEENE_STAR, MULTI_SPAN_BINDING, NO_BINDING, NO_KLEENE_OP, SINGLE_SPAN_BINDING`

Constructor Summary
`BasicPatternElement()` Construction.

Method Summary
`void` `addConstraint(Constraint newConstraint)` Add a constraint.
`Object` `clone()` Need cloning for processing of macro references.
`void` `finish()` Finish: replace dynamic data structures with Java arrays; called after parsing.
`Constraint[]` `getConstraints()`
`AnnotationSet` `getMatchedAnnots()` Access to the annotations that have been matched.
`boolean` `matches(Document doc, int position, MutableInteger newPosition)` Does this element match the document at this position?
`void` `reset()` Reset: clear last failure point and matched annotations list.
`void` `rollback(int arity)` Multilevel rollback of the annotation cache.
`String` `shortDesc()` Returns a short description.
`String` `toString()` Create a string representation of the object.
`String` `toString(String pad)` Create a string representation of the object.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### BasicPatternElement

    public BasicPatternElement()

  Construction.

Method Detail

### getMatchedAnnots

    public AnnotationSet getMatchedAnnots()

  Access to the annotations that have been matched.
  Overrides:
    `getMatchedAnnots` in class `PatternElement`

### clone

    public Object clone()

  Need cloning for processing of macro references. See comments on `PatternElement.clone()`
  Overrides:
    `clone` in class `PatternElement`

### addConstraint

    public void addConstraint(Constraint newConstraint)

  Add a constraint. Ensures that only one constraint of any given annotation type exists.

### finish

    public void finish()

  Finish: replace dynamic data structures with Java arrays; called after parsing.

### reset

    public void reset()

  Reset: clear last failure point and matched annotations list.
  Overrides:
    `reset` in class `PatternElement`

### rollback

    public void rollback(int arity)

  Multilevel rollback of the annotation cache.
  Overrides:
    `rollback` in class `PatternElement`

### matches

    public boolean matches(Document doc,
                           int position,
                           MutableInteger newPosition)

  Does this element match the document at this position?

### toString

    public String toString()

  Create a string representation of the object.
  Overrides:
    `toString` in class `Object`

### toString

    public String toString(String pad)

  Create a string representation of the object.
  Overrides:
    `toString` in class `PatternElement`

### shortDesc

    public String shortDesc()

  Returns a short description.

### getConstraints

    public Constraint[] getConstraints()